000010*@M	       MAIN
000020 IDENTIFICATION DIVISION.
000030 PROGRAM-ID. PRTLIST.
000040 DATE-COMPILED.
000050* ------------------------: GS Printer Enumeration Demo
000060*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000070 ENVIRONMENT DIVISION.
      * 090603ja-68 Set to default to Basic mode instead of detail	090603ja
000080*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000090 CONFIGURATION SECTION.
000100 SOURCE-COMPUTER. IBM-PC.
000110 OBJECT-COMPUTER. IBM-PC.
000120*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000130 DATA DIVISION.
000140*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000150 WORKING-STORAGE SECTION.
       01  V--VERSION-LEVEL PIC 9(3) VALUE 68.				090603ja
000170*
000180* ------------------------: Copy a main panel
000190	       COPY PRTMAIN.
000200* ------------------------: Copy the panel for the PRTPANL
000210	       COPY PRTPANL.
000220* 			: GUI ScreenIO API call copybooks
000230	       COPY WIN32API.
000240	       COPY GETPRINT.
000250*
000260 01  WS-EVENT-ID			    PIC Z(9).
000270 01  WSIDX			    PIC S9(4) COMP-5.
000280 01  DUMMY			    PIC X.
000290* -====-
000300 01  WS-TIME.
000310	   05  WS-HH			    PIC 99 VALUE 0.
000320	   05  WS-MM			    PIC 99 VALUE 0.
000330	   05  WS-SS			    PIC 99 VALUE 0.
000340*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000350 PROCEDURE DIVISION.
000360*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000370 0001-MAIN-DRIVER.
000380*
000390	   PERFORM 0103-INITIALIZE-GS.
000400	   MOVE SPACE TO SEL-SERVER
000410	   SET SEL-DETAIL-OFF RUN-CLIENT-ON TO TRUE			090603ja
000420	   SET SEL-BASIC-ON RUN-SERVER-OFF SEL-NT2KXP-OFF TO TRUE	090603ja
000430	   PERFORM 0101-LOAD
000440*
000450* ------------------------: Display the panel loop till cancel
000460*
000470	   PERFORM WITH TEST AFTER
000480		 UNTIL PRTPANL-EVENT-CLOSE-AND-STOP
000490		 OR PRTPANL-CANCEL
000500*
000510	     CALL 'GS' USING PRTPANL-1
000520			     PRTPANL-2
000530			     PRTPANL-3
000540			     PRTPANL-4
000550*
000560	     EVALUATE TRUE
000570* 			: Reset the listview and reload it
000580	       WHEN PRTPANL-CHECKAGAIN
000590		 SET PRTLV-RESET TO TRUE
000600		 PERFORM 0101-LOAD
000610*
000620	       WHEN PRTLV-B
000630		 IF PRTLV-SEL1-KEY > ZERO
000640		   PERFORM 0102-LOAD-INDICATORS
000650		 END-IF
000660*
000670	     END-EVALUATE
000680	   END-PERFORM.
000690*
000700* ------------------------: Close the main before doing a STOP RUN
000710*
000720	   SET PRTMAIN-DO-CLOSE TO TRUE.
000730	   CALL 'GS' USING PRTMAIN-1
000740			   PRTMAIN-2
000750			   PRTMAIN-3
000760			   PRTMAIN-4.
000770	   STOP RUN.
000780*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000790 0100-GS-UTILITY SECTION.
000800* -====-
000810 0101-LOAD.
000820* 			: This section Loads the listview with
000830* 			: The info about the recovered printers
000840* 			: after making a call to API-GetPrinters
000850	   MOVE ZERO TO ATT-DIRECT-NO-SPOOL
000860			ATT-DEFAULT
000870			ATT-SHARED
000880			ATT-NETWORK
000890			ATT-LOCAL
000900			ATT-FAX
000910			STAT-PAUSED
000920			STAT-ERROR
000930			STAT-PAPER-JAM
000940			STAT-PAPER-OUT
000950			STAT-MANUAL-FEED
000960			STAT-PAPER-PROBLEM
000970			STAT-OFFLINE
000980			STAT-IO-ACTIVE
000990			STAT-BUSY
001000			STAT-PRINTING
001010			STAT-OUTPUT-BIN-FULL
001020			STAT-WAITING
001030			STAT-NOT-AVAILABLE
001040			STAT-PROCESSING
001050			STAT-INITIALIZING
001060			STAT-WARMING-UP
001070			STAT-TONER-LOW
001080			STAT-NO-TONER
001090			STAT-PAGE-PUNT
001100			STAT-USER-INTERVENTION
001110			STAT-OUT-OF-MEMORY
001120			STAT-DOOR-OPEN
001130			STAT-SERVER-UNKNOWN
001140			STAT-POWER-SAVE
001150			JOB-COUNT-PENDING.
001160*
001170* 			: This makes sure all of our variable
001180* 			: length data storage is available
001190	   SET GP-PRINT-MAX TO TRUE
001200* 			: If they keyd in a print server name
001210* 			: send that to the api, else low-values
001220	   IF SEL-SERVER > SPACE
001230	     MOVE SEL-SERVER TO GP-SERVER-HOST-NAME
001240	   ELSE
001250	     SET GP-GET-ALL-MY-PRINTERS TO TRUE
001260	   END-IF
001270	   MOVE LOW-VALUES TO GP-PRINTER-TABLE-AREA
001280* 			: Honor their level of detail
001290	   IF SEL-DETAIL-ON
001300	     SET GP-INFO-DETAILED TO TRUE
001310	   ELSE
	     IF SEL-NT2KXP-ON
001320	      SET GP-INFO-NT2KXP TO TRUE
001310	     ELSE
001320	       SET GP-INFO-BASIC TO TRUE
001330	     END-IF
001330	   END-IF
001340* 			: If running client server, set the
001350* 			: switch to indicate where to get
001360* 			: printer list.  If running stand alone
001370* 			: it does not matter which is set.
001380	   IF RUN-SERVER-ON
001390	     SET WIN32API-EXECUTE-API-ON-SERVER TO TRUE
001400	   END-IF
001410* 			:---------------------------------------
001420* ------------------------: Now call the Gui ScreenIO API to
001430* 			: get a list of the printers
001440* 			:---------------------------------------
001450	   SET API-GETPRINTERS TO TRUE
001460	   CALL 'GSWINAPI' USING WIN32API-PARMS
001470				 GP-SERVER-HOST-NAME
001480				 GP-INFO-LEVEL
001490				 GP-PRINT-COUNT
001500				 GP-PRINTER-TABLE-AREA
001510				 DUMMY
001520				 DUMMY
001530* 			: Now if the API succeeded, extract
001540* 			: all of the printers from the table and
001550* 			: load our listview
001560	   IF NOT WIN32API-FAILED
001570	     PERFORM
001580		   VARYING WSIDX FROM 1 BY 1
001590		   UNTIL WSIDX > GP-PRINT-COUNT
001600	       MOVE GP-PRINTER-NAME (WSIDX) TO PRTLV-LV-PRINTER-NAME
001610					       (WSIDX)
001620	       MOVE GP-PORT-NAME (WSIDX) TO PRTLV-LV-PORT-NAME (WSIDX)
001630	       MOVE GP-SERVER-NAME (WSIDX) TO PRTLV-LV-SERVER-NAME
001640					      (WSIDX)
001650	       MOVE GP-SHARE-NAME (WSIDX) TO PRTLV-LV-SHARE-NAME (WSIDX)
001660	       MOVE GP-PRINTER-DRIVER-NAME (WSIDX) TO
001670		   PRTLV-LV-DRIVER-NAME (WSIDX)
001680	       MOVE GP-PRINTER-COMMENT (WSIDX) TO PRTLV-LV-COMMENT
001690						  (WSIDX)
001700	       MOVE GP-PRINTER-LOCATION (WSIDX) TO PRTLV-LV-LOCATION
001710						   (WSIDX)
001720* 			: Set the key and percent to the index
001730* 			: becaause we sized this listview to
001740* 			: hold exactly what our printer list
001750* 			: size is... (lazy programmers!)
001760	       MOVE WSIDX TO PRTLV--KEY (WSIDX) PRTLV--PERCENT (WSIDX)
001770	       MOVE PRTPANL-RESTORE-DEFAULT-COLOR TO PRTLV--COLOR
001780						     (WSIDX)
001790* 			: Highlight my default
001800	       IF GP-ATT-DEFAULT (WSIDX) > ZERO
001810		 MOVE PRTPANL-MY-DEFAULT TO PRTLV--COLOR (WSIDX)
001820* 			: And load its atts-n-stats
001830		 MOVE WSIDX TO PRTLV-SEL1-KEY
001840		 SET PRTLV--SELECTED (WSIDX) TO TRUE
001850		 PERFORM 0102-LOAD-INDICATORS
001860	       END-IF
001870* 			: Flag selected error status
001880	       IF GP-STAT-PAUSED (WSIDX) > ZERO
001890		     OR GP-STAT-PAPER-JAM (WSIDX) > ZERO
001900		     OR GP-STAT-PAPER-OUT (WSIDX) > ZERO
001910		     OR GP-STAT-PAPER-PROBLEM (WSIDX) > ZERO
001920		     OR GP-STAT-OFFLINE (WSIDX) > ZERO
001930		     OR GP-STAT-OUTPUT-BIN-FULL (WSIDX) > ZERO
001940		     OR GP-STAT-NO-TONER (WSIDX) > ZERO
001950		     OR GP-STAT-USER-INTERVENTION (WSIDX) > ZERO
001960		     OR GP-STAT-DOOR-OPEN (WSIDX) > ZERO
001970		 MOVE PRTPANL-ERROR-STATUS TO PRTLV--COLOR (WSIDX)
001980	       END-IF
001990	       IF WSIDX = 1
002000		 MOVE ZERO TO PRTLV--PERCENT (WSIDX)
002010	       END-IF
002020	       IF WSIDX = GP-PRINT-COUNT
002030		 MOVE 100 TO PRTLV--PERCENT (WSIDX)
002040	       END-IF
002050*
002060	     END-PERFORM.
002070*
002080 0102-LOAD-INDICATORS.
002090* 			: Here we load the individual check
002100* 			: boxes for the Attributes and Status
002110* 			: of the selected printers.
002120* 			: These are output only fields.
002130* 			: Because attributes and status are
002140* 			: 0 or 1 we can move them directly
002150* 			: to the Checkbox.
002160	   SET GPPRTDEX TO PRTLV-SEL1-KEY
002170	   MOVE GP-ATT-DIRECT-NO-SPOOL (GPPRTDEX) TO ATT-DIRECT-NO-SPOOL
002180	   MOVE GP-ATT-DEFAULT (GPPRTDEX) TO ATT-DEFAULT
002190	   MOVE GP-ATT-SHARED (GPPRTDEX) TO ATT-SHARED
002200	   MOVE GP-ATT-NETWORK (GPPRTDEX) TO ATT-NETWORK
002210	   MOVE GP-ATT-LOCAL (GPPRTDEX) TO ATT-LOCAL
002220	   MOVE GP-ATT-FAX (GPPRTDEX) TO ATT-FAX
002230	   MOVE GP-STAT-PAUSED (GPPRTDEX) TO STAT-PAUSED
002240	   MOVE GP-STAT-ERROR (GPPRTDEX) TO STAT-ERROR
002250	   MOVE GP-STAT-PAPER-JAM (GPPRTDEX) TO STAT-PAPER-JAM
002260	   MOVE GP-STAT-PAPER-OUT (GPPRTDEX) TO STAT-PAPER-OUT
002270	   MOVE GP-STAT-MANUAL-FEED (GPPRTDEX) TO STAT-MANUAL-FEED
002280	   MOVE GP-STAT-PAPER-PROBLEM (GPPRTDEX) TO STAT-PAPER-PROBLEM
002290	   MOVE GP-STAT-OFFLINE (GPPRTDEX) TO STAT-OFFLINE
002300	   MOVE GP-STAT-IO-ACTIVE (GPPRTDEX) TO STAT-IO-ACTIVE
002310	   MOVE GP-STAT-BUSY (GPPRTDEX) TO STAT-BUSY
002320	   MOVE GP-STAT-PRINTING (GPPRTDEX) TO STAT-PRINTING
002330	   MOVE GP-STAT-OUTPUT-BIN-FULL (GPPRTDEX) TO
002340	       STAT-OUTPUT-BIN-FULL
002350	   MOVE GP-STAT-WAITING (GPPRTDEX) TO STAT-WAITING
002360	   MOVE GP-STAT-NOT-AVAILABLE (GPPRTDEX) TO STAT-NOT-AVAILABLE
002370	   MOVE GP-STAT-PROCESSING (GPPRTDEX) TO STAT-PROCESSING
002380	   MOVE GP-STAT-INITIALIZING (GPPRTDEX) TO STAT-INITIALIZING
002390	   MOVE GP-STAT-WARMING-UP (GPPRTDEX) TO STAT-WARMING-UP
002400	   MOVE GP-STAT-TONER-LOW (GPPRTDEX) TO STAT-TONER-LOW
002410	   MOVE GP-STAT-NO-TONER (GPPRTDEX) TO STAT-NO-TONER
002420	   MOVE GP-STAT-PAGE-PUNT (GPPRTDEX) TO STAT-PAGE-PUNT
002430	   MOVE GP-STAT-USER-INTERVENTION (GPPRTDEX) TO
002440	       STAT-USER-INTERVENTION
002450	   MOVE GP-STAT-OUT-OF-MEMORY (GPPRTDEX) TO STAT-OUT-OF-MEMORY
002460	   MOVE GP-STAT-DOOR-OPEN (GPPRTDEX) TO STAT-DOOR-OPEN
002470	   MOVE GP-STAT-SERVER-UNKNOWN (GPPRTDEX) TO STAT-SERVER-UNKNOWN
002480	   MOVE GP-STAT-POWER-SAVE (GPPRTDEX) TO STAT-POWER-SAVE
002490	   MOVE GP-JOB-COUNT-PENDING (GPPRTDEX) TO JOB-COUNT-PENDING.
002500*
002510 0103-INITIALIZE-GS.
002520* 			:---------------------------------------
002530* ------------------------: Open the application window (the
002540* 			: container for this application)
002550* 			:---------------------------------------
002560	   CALL 'GS' USING PRTMAIN-1
002570			   PRTMAIN-2
002580			   PRTMAIN-3
002590			   PRTMAIN-4.
